Skip to content

Overview

  • Version: 2.0.0
  • Servers: https://store.xsolla.com/api
  • Contact Us by Email
  • Contact URL: https://xsolla.com/
  • Required TLS version: 1.2

The Catalog API allows you to configure a catalog of in-game items on the Xsolla side and display the catalog to users in your store.

The API allows you to manage the following catalog entities:

  • Virtual items — in-game items such as weapons, skins, boosters.
  • Virtual currency — virtual money used to purchase virtual goods.
  • Virtual currency packages — predefined bundles of virtual currency.
  • Bundles — combined packages of virtual items, currency, or game keys sold as a single SKU.
  • Game keys — keys for games and DLCs distributed via platforms like Steam or other DRM providers.
  • Groups — logical groupings for organizing and sorting items within the catalog.

API calls

The API is divided into the following groups:

  • Admin — calls for creating, updating, deleting, and configuring catalog items and groups. Authenticated via basic access authentication with your merchant or project credentials. Not intended for storefront use.
  • Catalog — calls for retrieving items and building custom storefronts for end users. Designed to handle high-load scenarios. Support optional user JWT authorization to return personalized data such as user-specific limits and active promotions.

Authentication

API calls require authentication either on behalf of a user or on behalf of a project. The authentication scheme used is specified in the Security section in the description of each call.

Authentication using user's JWT

User's JWT authentication is used when a request is sent from a browser, mobile application, or game. By default, the XsollaLoginUserJWT scheme is applied. For details on how to create a token, see the Xsolla Login API documentation.

The token is passed in the Authorization header in the following format: Authorization: Bearer <user_JWT>, where <user_JWT> is the user token. The token identifies the user and provides access to personalized data. You can try this call using the following test token:

eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJleHAiOjE5NjIyMzQwNDgsImlzcyI6Imh0dHBzOi8vbG9naW4ueHNvbGxhLmNvbSIsImlhdCI6MTU2MjE0NzY0OCwidXNlcm5hbWUiOiJ4c29sbGEiLCJ4c29sbGFfbG9naW5fYWNjZXNzX2tleSI6IjA2SWF2ZHpDeEVHbm5aMTlpLUc5TmMxVWFfTWFZOXhTR3ZEVEY4OFE3RnMiLCJzdWIiOiJkMzQyZGFkMi05ZDU5LTExZTktYTM4NC00MjAxMGFhODAwM2YiLCJlbWFpbCI6InN1cHBvcnRAeHNvbGxhLmNvbSIsInR5cGUiOiJ4c29sbGFfbG9naW4iLCJ4c29sbGFfbG9naW5fcHJvamVjdF9pZCI6ImU2ZGZhYWM2LTc4YTgtMTFlOS05MjQ0LTQyMDEwYWE4MDAwNCIsInB1Ymxpc2hlcl9pZCI6MTU5MjR9.GCrW42OguZbLZTaoixCZgAeNLGH2xCeJHxl8u8Xn2aI

Alternatively, you can use a token for opening the payment UI.

Basic HTTP authentication

Basic HTTP authentication is used for server-to-server interactions, when an API call is sent directly from your server rather than from a user's browser or mobile application. HTTP Basic authentication with an API key is typically used.

Note

The API key is confidential and must not be stored or used in client applications.

With basic server-side authentication, all API requests must include the following header:

  • for basicAuthAuthorization: Basic <your_authorization_basic_key>, where your_authorization_basic_key is the project_id:api_key pair encoded in Base64
  • for basicMerchantAuthAuthorization: Basic <your_authorization_basic_key>, where your_authorization_basic_key is the merchant_id:api_key pair encoded in Base64

You can find the parameter values in Publisher Account:

  • merchant_id is displayed:
    • In Company settings > Company.
    • In the URL in the browser address bar on any Publisher Account page. The URL has the following format: https://publisher.xsolla.com/<merchant_id>.
  • project_id is displayed:
    • Next to the project name in Publisher Account.
    • In the URL in the browser address bar when working on a project in Publisher Account. The URL has the following format: https://publisher.xsolla.com/<merchant_id>/projects/<project_id>.
  • api_key is shown in Publisher Account only at the time of creation and must be stored securely on your side. You can create an API key in the following sections:
Notice

If a required API call doesn't include the project_id path parameter, use an API key that is valid across all company projects for authorization.

For more information about working with API keys, see the API references.

Authentication with guest access support

The AuthForCart authentication scheme is used for cart purchases and supports two modes:

  1. Authentication with a user's JWT. The token is passed in the Authorization header in the following format: Authorization: Bearer <user_JWT>, where <user_JWT> is the user token. The token identifies the user and provides access to personalized data. You can try this call using the following test token:
eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJleHAiOjE5NjIyMzQwNDgsImlzcyI6Imh0dHBzOi8vbG9naW4ueHNvbGxhLmNvbSIsImlhdCI6MTU2MjE0NzY0OCwidXNlcm5hbWUiOiJ4c29sbGEiLCJ4c29sbGFfbG9naW5fYWNjZXNzX2tleSI6IjA2SWF2ZHpDeEVHbm5aMTlpLUc5TmMxVWFfTWFZOXhTR3ZEVEY4OFE3RnMiLCJzdWIiOiJkMzQyZGFkMi05ZDU5LTExZTktYTM4NC00MjAxMGFhODAwM2YiLCJlbWFpbCI6InN1cHBvcnRAeHNvbGxhLmNvbSIsInR5cGUiOiJ4c29sbGFfbG9naW4iLCJ4c29sbGFfbG9naW5fcHJvamVjdF9pZCI6ImU2ZGZhYWM2LTc4YTgtMTFlOS05MjQ0LTQyMDEwYWE4MDAwNCIsInB1Ymxpc2hlcl9pZCI6MTU5MjR9.GCrW42OguZbLZTaoixCZgAeNLGH2xCeJHxl8u8Xn2aI

Alternatively, you can use a token for opening the payment UI.

  1. Simplified mode without Authorization header. This mode is used only for unauthorized users and can be applied only for game key sales. Instead of a token, the request must include the following headers:
    • x-unauthorized-id with a request ID
    • x-user with the user's email address encoded in Base64

Core entity structure

Items of all types (virtual items, bundles, virtual currency, and keys) use a similar data structure. Understanding the basic structure simplifies working with the API and helps you navigate the documentation more easily.

Note

Some calls may include additional fields but they don't change the basic structure.

Identification

  • merchant_id — company ID in Publisher Account
  • project_id — project ID in Publisher Account
  • sku — item SKU, unique within the project

Store display

  • name — item name
  • description — item description
  • image_url — image URL
  • is_enabled — item availability
  • is_show_in_store — whether the item is displayed in the catalog

For more information about managing item availability in the catalog, see the documentation.

Organization

  • type — item type, for example, a virtual item (virtual_item) or bundle (bundle)
  • groups — groups the item belongs to
  • order — display order in the catalog

Sale conditions

  • prices — prices in real or virtual currency
  • limits — purchase limits
  • periods — availability periods
  • regions — regional restrictions

Example of core entity structure:

{
  "attributes": [],
  "bundle_type": "virtual_currency_package",
  "content": [
    {
      "description": {
        "en": "Main in-game currency"
      },
      "image_url": "https://.../image.png",
      "name": {
        "en": "Crystals",
        "de": "Kristalle"
      },
      "quantity": 500,
      "sku": "com.xsolla.crystal_2",
      "type": "virtual_currency"
    }
  ],
  "description": {
    "en": "Crystals x500"
  },
  "groups": [],
  "image_url": "https://.../image.png",
  "is_enabled": true,
  "is_free": false,
  "is_show_in_store": true,
  "limits": {
    "per_item": null,
    "per_user": null,
    "recurrent_schedule": null
  },
  "long_description": null,
  "media_list": [],
  "name": {
    "en": "Medium crystal pack"
  },
  "order": 1,
  "periods": [
    {
      "date_from": null,
      "date_until": "2020-08-11T20:00:00+03:00"
    }
  ],
  "prices": [
    {
      "amount": 20,
      "country_iso": "US",
      "currency": "USD",
      "is_default": true,
      "is_enabled": true
    }
  ],
  "regions": [],
  "sku": "com.xsolla.crystal_pack_2",
  "type": "bundle",
  "vc_prices": []
}

Basic purchase flow

The Xsolla API allows you to implement in-game store logic, including retrieving the item catalog, managing the cart, creating orders, and tracking their status. Depending on the integration scenario, API calls are divided into Admin and Catalog subsections, which use different authentication schemes.

The following example shows a basic flow for setting up and operating a store, from item creation to purchase.

Create items and groups (Admin)

Create an item catalog for your store, such as virtual items, bundles, or virtual currency.

Example API calls:

Set up promotions, chains, and limits (Admin)

Configure user acquisition and monetization tools, such as discounts, bonuses, daily rewards, or offer chains.

Example API calls:

Get item information (Client)

Configure item display in your application.

Notice

Do not use API calls from the Admin subsection to build a user catalog. These API calls have rate limits and aren't intended for user traffic.

Example API calls:

Note

By default, catalog API calls return items that are currently available in the store at the time of the request. To retrieve items that are not yet available or are no longer available, include the parameter "show_inactive_time_limited_items": 1 in the catalog request.

Sell items

You can sell items using the following methods:

  • Fast purchase — sell one SKU multiple times.
  • Cart purchase — the user adds items to the cart, removes items, and updates quantities within a single order.

If an item is purchased using virtual currency instead of real money, use the Create order with specified item purchased by virtual currency API call. The payment UI is not required, as the charge is processed when the API call is executed.

For free item purchase, use the Create order with specified free item API call or the Create order with free cart API call. The payment UI is not required — the order is immediately set to the done status.

Fast purchase

Use the client-side API call to create an order with a specified item. The call returns a token used to open the payment UI.

Note

Discount information is available to the user only in the payment UI. Promo codes are not supported.

Cart purchase

Cart setup and purchase can be performed on the client or on the server side.

Set up and purchase a cart on the client

Implement the logic of adding and removing items by yourself. Before calling the API for setting up a cart, you will not have information about which promotions will be applied to the purchase. This means that the total cost and details of the added bonus items will not be known.

Implement the following cart logic:

  1. After the player has filled a cart, use the Fill cart with items API call. The call returns the current information about the selected items (prices before and after discounts, bonus items).
  2. Update the cart contents based on user actions:
Note

To get the current status of the cart, use the Get current user's cart API call.
  1. Use the Create order with all items from current cart API call. The call returns the order ID and payment token. The newly created order is set to new status by default.

Set up and purchase a cart on the server

This setup option may take longer for setting the cart up, since each change to the cart must be accompanied by API calls.

Implement the following cart logic:

  1. After the player has filled a cart, use the Fill cart with items API call. The call returns current information about the selected items (prices before and after discounts, bonus items).
  2. Use the Create order with all items from current cart API call. The call returns the order ID and payment token. The newly created order is set to new status by default.

Open payment UI

Use the returned token to open the payment UI in a new window. Other ways to open the payment UI are described in the documentation.

ActionEndpoint
Open in production environment.https://secure.xsolla.com/paystation4/?token={token}
Open in sandbox mode.https://sandbox-secure.xsolla.com/paystation4/?token={token}
Note

Use sandbox mode during development and testing. Test purchases don't charge real accounts. You can use test bank cards.

After the first real payment is made, a strict sandbox payment policy takes effect. A payment in sandbox mode is available only to users specified in Publisher Account > Company settings > Users.

Buying virtual currency and items for real currency is possible only after signing a license agreement with Xsolla. To do this, in Publisher Account, go to Agreements & Taxes > Agreements, complete the agreement form, and wait for confirmation. It may take up to 3 business days to review the agreement.

To enable or disable sandbox mode, change the value of the sandbox parameter in the request for fast purchase and cart purchase. Sandbox mode is off by default.

Possible order statuses:

  • new — order created
  • paid — payment received
  • done — item delivered
  • canceled — order canceled
  • expired — payment expired

Track order status using one of the following methods:

Pagination

API calls that return large sets of records (for example, when building a catalog) return data in pages. Pagination is a mechanism that limits the number of items returned in a single API response and allows you to retrieve subsequent pages sequentially.

Use the following parameters to control the number of returned items:

  • limit — number of items per page
  • offset — index of the first item on the page (numbering starts from 0)
  • has_more — indicates whether another page is available
  • total_items_count — total number of items

Example request:

GET /items?limit=20&offset=40

Response example:

{
  "items": [...],
  "has_more": true,
  "total_items_count": 135
}

It is recommended to send subsequent requests until the response returns has_more = false.

Date and time format

Dates and time values are passed in the ISO 8601 format.

The following are supported:

  • UTC offset
  • null value when there is no time restriction for displaying an item
  • Unix timestamp (in seconds) used in some fields

Format: YYYY-MM-DDTHH:MM:SS±HH:MM

Example: 2026-03-16T10:00:00+03:00

Localization

Xsolla supports localization of user-facing fields such as item name and description. Localized values are passed as an object where the language code is used as the key. The full list of supported languages is available in the documentation.

Supported fields

Localization can be specified for the following parameters:

  • name
  • description
  • long_description

Locale format

The locale key can be specified in one of the following formats:

  • Two-letter language code: en, ru
  • Five-letter language code: en-US, ru-RU, de-DE

Examples

Example with a two-letter language code:

{
  "name": {
    "en": "Starter Pack",
    "ru": "Стартовый набор"
  }
}

Example with a five-letter language code:

{
  "description": {
    "en-US": "Premium bundle",
    "de-DE": "Premium-Paket"
  }
}

Error response format

If an error occurs, the API returns an HTTP status and a JSON response body. The full list of store-related errors is available in the documentation.

Response example:

{
  "errorCode": 1102,
  "errorMessage": "Validation error",
  "statusCode": 422,
  "transactionId": "c9e1a..."
}
  • errorCode — error code.
  • errorMessage — short error description.
  • statusCode — HTTP response status.
  • transactionId — request ID. Returned only in some cases.
  • errorMessageExtended — additional error details, such as request parameters. Returned only in some cases.

Extended response example:

{
  "errorCode": 7001,
  "errorMessage": "Chain not found",
  "errorMessageExtended": {
    "chain_id": "test_chain_id",
    "project_id": "test_project_id",
    "step_number": 2
  },
  "statusCode": 404
}

Common HTTP status codes

  • 400 — invalid request
  • 401 — authentication error
  • 403 — insufficient permissions
  • 404 — resource not found
  • 422 — validation error
  • 429 — rate limit exceeded

Recommendations

  • Handle the HTTP status and the response body together.
  • Use errorCode to process errors related to application logic.
  • Use transactionId to identify requests more quickly when analyzing errors.
Download OpenAPI description
Languages
Servers
https://store.xsolla.com/api/
Mock server
https://xsolla.redocly.app/_mock/api/catalog/
Operations

Get virtual currencyServer-sideAdmin

Request

Gets the virtual currency within a project for administration.

Note

Do not use this endpoint for building a store catalog.
Security
basicAuth
Path
project_idintegerrequired

Project ID. You can find this parameter in your Publisher Account next to the project name and in the browser address bar when working with a project. The URL has the following format: https://publisher.xsolla.com/<merchant_id>/projects/<project_id>.

Example: 44056
virtual_currency_skustringrequired

Virtual currency SKU.

Example: crystal
curl -i -X GET \
  -u <username>:<password> \
  https://store.xsolla.com/api/v2/project/44056/admin/items/virtual_currency/sku/crystal

Responses

The specified virtual currency was successfully received.

Bodyapplication/json
skustring(Virtual-Items-Currency_sku)[ 1 .. 255 ] characters^[a-zA-Z0-9_\-–.]*$

Unique item ID. The SKU may contain only lowercase and uppercase Latin alphanumeric characters, periods, dashes, and underscores.

name(two-letter (object or null)) or (five-letter (object or null))(name-localization-object)

Object with localizations for item’s name. Accepts value in one of two formats: two-letter lowercase language codes (e.g., en) or five-character language codes (e.g., en-US). While both formats are accepted as input, responses return two-letter lowercase language codes. When both options for the same language are provided (e.g., en and en-US), the last provided value is stored. You can find the full list of supported languages in the documentation.

Any of:

Two-letter lowercase language codes.

name.​enstring or null

English

name.​arstring or null

Arabic

name.​bgstring or null

Bulgarian

name.​cnstring or null

Chinese (Simplified)

name.​csstring or null

Czech

name.​destring or null

German

name.​esstring or null

Spanish (Spain)

name.​frstring or null

French

name.​hestring or null

Hebrew

name.​itstring or null

Italian

name.​jastring or null

Japanese

name.​kostring or null

Korean

name.​plstring or null

Polish

name.​ptstring or null

Portuguese

name.​rostring or null

Romanian

name.​rustring or null

Russian

name.​thstring or null

Thai

name.​trstring or null

Turkish

name.​twstring or null

Chinese (Traditional)

name.​vistring or null

Vietnamese

name.​kmstring or null

Khmer

name.​idstring or null

Indonesian

name.​lostring or null

Lao

name.​mystring or null

Burmese

name.​phstring or null

Filipino

name.​nestring or null

Nepali

description(two-letter (object or null)) or (five-letter (object or null))(description-localization-object)

Object with localizations for item’s description. Accepts value in one of two formats: two-letter lowercase language codes (e.g., en) or five-character locale codes (e.g., en-US). While both formats are accepted as input, responses return two-letter lowercase language codes. When both options for the same language are provided (e.g., en and en-US), the last provided value is stored. You can find the full list of supported languages in the documentation.

Any of:

Two-letter lowercase language codes.

description.​enstring or null

English

description.​arstring or null

Arabic

description.​bgstring or null

Bulgarian

description.​cnstring or null

Chinese (Simplified)

description.​csstring or null

Czech

description.​destring or null

German

description.​esstring or null

Spanish (Spain)

description.​frstring or null

French

description.​hestring or null

Hebrew

description.​itstring or null

Italian

description.​jastring or null

Japanese

description.​kostring or null

Korean

description.​plstring or null

Polish

description.​ptstring or null

Portuguese

description.​rostring or null

Romanian

description.​rustring or null

Russian

description.​thstring or null

Thai

description.​trstring or null

Turkish

description.​twstring or null

Chinese (Traditional)

description.​vistring or null

Vietnamese

description.​kmstring or null

Khmer

description.​idstring or null

Indonesian

description.​lostring or null

Lao

description.​mystring or null

Burmese

description.​phstring or null

Filipino

description.​nestring or null

Nepali

long_description(two-letter (object or null)) or (five-letter (object or null))(long-description-localization-object)

Object with localizations for long description of item. Accepts value in one of two formats: two-letter lowercase language codes (e.g., en) or five-character locale codes (e.g., en-US). While both formats are accepted as input, responses return two-letter lowercase language codes. When both variants for the same language are provided (e.g., en and en-US), the last provided value is stored. You can find the full list of supported languages in the documentation.

Any of:

Two-letter lowercase language codes.

long_description.​enstring or null

English

long_description.​arstring or null

Arabic

long_description.​bgstring or null

Bulgarian

long_description.​cnstring or null

Chinese (Simplified)

long_description.​csstring or null

Czech

long_description.​destring or null

German

long_description.​esstring or null

Spanish (Spain)

long_description.​frstring or null

French

long_description.​hestring or null

Hebrew

long_description.​itstring or null

Italian

long_description.​jastring or null

Japanese

long_description.​kostring or null

Korean

long_description.​plstring or null

Polish

long_description.​ptstring or null

Portuguese

long_description.​rostring or null

Romanian

long_description.​rustring or null

Russian

long_description.​thstring or null

Thai

long_description.​trstring or null

Turkish

long_description.​twstring or null

Chinese (Traditional)

long_description.​vistring or null

Vietnamese

long_description.​kmstring or null

Khmer

long_description.​idstring or null

Indonesian

long_description.​lostring or null

Lao

long_description.​mystring or null

Burmese

long_description.​phstring or null

Filipino

long_description.​nestring or null

Nepali

groupsArray of objects(Virtual-Items-Currency_admin-groups-response)

Groups the item belongs to.

groups[].​external_idstring
Example: "horror"
groups[].​nameobject

Name of item. Should contain key/value pairs where key is a locale with "^[a-z]{2}" format, value is string.

Default {"en":"Horror"}
Example: {"en":"Horror","de":"Horror"}
groups[].​name.​property name*stringadditional property
attributesArray of objects(Virtual-Items-Currency_admin-attributes)

List of attributes.

Example: [{"external_id":"attribute_external_id","name":{"en":"Attribute name","de":"Attributname"},"values":[{"external_id":"value_1","name":{"en":"value 1","de":"wert 1"}},{"external_id":"value_2","name":{"en":"value 2","de":"wert 2"}}]}]
attributes[].​external_idstring(admin-attribute-external_id)[ 1 .. 255 ] characters^[a-zA-Z0-9-_]+$required

Unique attribute ID. The external_id may contain only lowercase and uppercase Latin alphanumeric characters, dashes, and underscores.

Example: "attribute_external_id"
attributes[].​nameobject(admin-attribute-name)

Object with localizations for attribute's name. Keys are specified in ISO 3166-1.

Example: {"en":"Attribute name","de":"Attributname"}
attributes[].​name.​property name*stringadditional property
attributes[].​valuesArray of objects(attribute-value)required
Example: [{"external_id":"value_1","name":{"en":"value 1","de":"wert 1"}},{"external_id":"value_2","name":{"en":"value 2","de":"wert 2"}}]
attributes[].​values[].​external_idstring(value-external_id)[ 1 .. 255 ] characters^[-_.\d\w]+$required

Unique value ID for an attribute. The external_id may only contain lowercase Latin alphanumeric characters, dashes, and underscores.

Example: "value_external_id"
attributes[].​values[].​valueobject(value-name)required

Object with localizations of the value's name. Keys are specified in ISO 3166-1.

attributes[].​values[].​value.​property name*stringadditional property
media_listArray of objects(Virtual-Items-Currency_admin-media_list)

Item's additional assets such as screenshots, gameplay video and so on.

media_list[].​typestring

Type of media: image/video.

Enum"image""video"
Example: "image"
media_list[].​urlstring

Resource file.

Example: "https://cdn3.xsolla.com/img/misc/images/71ab1e12126f2103e1868076f0acb21a.jpg"
typestring(Virtual-Items-Currency_type)

Type of item: virtual_good/virtual_currency/bundle/physical_good/unit.

pricesArray of objects(Virtual-Items-Currency_admin-prices)
Example: [{"currency":"USD","amount":10.5,"is_default":true,"is_enabled":true,"country_iso":"US"}]
prices[].​currencystringrequired

Item price currency. Three-letter code per ISO 4217. Check the documentation for detailed information about currencies supported by Xsolla.

Example: "USD"
prices[].​amountnumber> 0required

Item price in real currency.

Example: 10.5
prices[].​is_defaultboolean

Whether it is the default price in real currency. Refer to our documentation for detailed information on price settings.

Default false
Example: true
prices[].​is_enabledboolean

Whether this price is used for displaying in the catalog and for purchasing the item. If false, the price is not used and another price is applied. Refer to our documentation for detailed information on price settings.

Default true
Example: true
prices[].​country_isostring or null

Country where this price is available. Two-letter code per ISO 3166-1 alpha 2.

Example: "US"
vc_pricesArray of objects(Virtual-Items-Currency_admin-get-vc_prices)
Example: [{"sku":"com.xsolla.gold_1","amount":10,"is_default":true}]
vc_prices[].​skustring(Virtual-Items-Currency_schemas-sku)required

Unique item ID. The SKU may contain only lowercase and uppercase Latin alphanumeric characters, periods, dashes, and underscores.

Example: "com.xsolla.gold_1"
vc_prices[].​amountnumber> 0required

Amount.

Example: 10
vc_prices[].​is_defaultboolean
Default false
Example: true
image_urlstring(Virtual-Items-Currency_admin-image_url)

Image URL.

is_enabledboolean(Virtual-Items-Currency_is_enabled)

Whether the item is available. If false, the item can't be purchased in the store or obtained as part of a bundle or within a marketing campaign. Refer to our documentation for detailed information about item availability.

is_freeboolean(value-is_free)

Whether the item is free.

is_paid_randomized_rewardboolean(value-is_paid_randomized_reward)

Whether the item is a randomized paid reward, e.g., a loot box.

orderinteger(Virtual-Items-Currency_order)

Item display order in the catalog. The higher the value, the lower the item appears in the list. If the values are the same, items are sorted by creation date, with newer items displayed higher.

is_show_in_storeboolean(Virtual-Items-Currency_is_show_in_store)

Whether the item is displayed in the catalog. If false and is_enabled: true, the item is not visible in the catalog but can be obtained as part of a bundle or within marketing campaigns. Refer to our documentation for detailed information about item availability.

regionsArray of objects(Virtual-Items-Currency_admin-regions)

Array of regions where the item is available. If the array is empty or not passed, the item is available in all regions.

regions[].​idinteger>= 1

Region ID within the project.

Refer to the regional sale restriction documentation and region management API calls for detailed information.

Example: 1
limitsobject or null(admin-item-limit-response)

Item limits.

limits.​per_userobject or null

Item limitation for a separate user.

limits.​per_user.​totalinteger

Maximum number of items a single user can purchase.

limits.​per_user.​limit_exceeded_visibilitystring(limit_exceeded_visibility)

Determines the visibility of the item in the catalog after the purchase limit is reached, until the next limit reset.

Applies to items for which recurring limit resets are configured in the recurrent_schedule array.

If limit resets are not configured, the item doesn't appear in the catalog after the purchase limit is reached, regardless of the limit_exceeded_visibility value.

Possible values:

  • show — The item is returned in catalog retrieval API calls after the purchase limit is reached. In client-side catalog retrieval API calls, once the limit is reached, the item is returned with the can_be_bought: false flag. The next reset date is returned in reset_next_date.
  • hide — The item is not returned in catalog retrieval API calls after the purchase limit is reached, until the limit is reset.
Enum"show""hide"
limits.​per_itemobject or null

Global item limitation.

limits.​per_item.​totalinteger

Maximum number of items all users can purchase.

limits.​per_item.​availableinteger

Remaining number of items all users can purchase.

limits.​per_item.​reservedinteger
limits.​per_item.​soldinteger
limits.​recurrent_scheduleobject or null(admin_recurrent_schedule_response)

Limit refresh period.

limits.​recurrent_schedule.​per_userinterval_type = daily (object) or interval_type = weekly (object) or interval_type = monthly (object) or interval_type = hourly (object)

User limit refresh period.

One of:

Daily type of user limits refresh.

limits.​recurrent_schedule.​per_user.​interval_typestring

Recurrent refresh period type.

Value"daily"
limits.​recurrent_schedule.​per_user.​timestring(full-time)

Time of limit refresh in the desired time zone (rounding to hours).

Example: "11:00:00+03:00"
limits.​recurrent_schedule.​per_user.​reset_next_dateinteger

Date and time when limits refresh (Unix Timestamp).

Example: 1677553200
limits.​recurrent_schedule.​per_user.​displayable_reset_start_datestring(date-time)

Date and time of the first limit refresh (ISO 8601).

Example: "2023-02-28T11:00:00+08:00"
limits.​recurrent_schedule.​per_user.​displayable_reset_next_datestring(date-time)

Date and time when limits should reset (ISO 8601).

Example: "2023-02-28T11:00:00+08:00"
periodsArray of objects(item-periods-response)

Item sales period.

periods[].​date_fromstring or null(date-time)

Date when the specified item will be available for sale.

Example: "2020-08-11T10:00:00+03:00"
periods[].​date_untilstring or null(date-time)

Date when the specified item will become unavailable for sale. Can be null.

Example: "2020-08-11T20:00:00+03:00"
custom_attributesobject(json)(item-custom-attributes-response)

A JSON object containing item attributes and values.

Response
application/json
{ "sku": "com.xsolla.crystal_1", "name": { "en": "Crystals", "ru": "Crystals" }, "type": "virtual_currency", "description": { "en": "Main in-game currency" }, "image_url": "https://cdn3.xsolla.com/img/misc/images/da33ab6cc1d7e5899cfdc5b6b6180fad.png", "long_description": null, "attributes": [ {} ], "is_free": false, "is_paid_randomized_reward": false, "order": 1, "groups": [], "prices": [ {} ], "media_list": [], "vc_prices": [], "is_enabled": true, "is_show_in_store": true, "regions": [], "limits": { "per_user": null, "per_item": null, "recurrent_schedule": null }, "periods": [], "custom_attributes": { "purchased": 0, "attr": "value" } }

Update virtual currencyServer-sideAdmin

Request

Updates a virtual currency.

Security
basicAuth
Path
project_idintegerrequired

Project ID. You can find this parameter in your Publisher Account next to the project name and in the browser address bar when working with a project. The URL has the following format: https://publisher.xsolla.com/<merchant_id>/projects/<project_id>.

Example: 44056
virtual_currency_skustringrequired

Virtual currency SKU.

Example: crystal
Bodyapplication/json
skustring(Virtual-Items-Currency_sku)[ 1 .. 255 ] characters^[a-zA-Z0-9_\-–.]*$required

Unique item ID. The SKU may contain only lowercase and uppercase Latin alphanumeric characters, periods, dashes, and underscores.

name(two-letter (object or null)) or (five-letter (object or null))(name-localization-object)required

Object with localizations for item’s name. Accepts value in one of two formats: two-letter lowercase language codes (e.g., en) or five-character language codes (e.g., en-US). While both formats are accepted as input, responses return two-letter lowercase language codes. When both options for the same language are provided (e.g., en and en-US), the last provided value is stored. You can find the full list of supported languages in the documentation.

Any of:

Two-letter lowercase language codes.

name.​enstring or null

English

name.​arstring or null

Arabic

name.​bgstring or null

Bulgarian

name.​cnstring or null

Chinese (Simplified)

name.​csstring or null

Czech

name.​destring or null

German

name.​esstring or null

Spanish (Spain)

name.​frstring or null

French

name.​hestring or null

Hebrew

name.​itstring or null

Italian

name.​jastring or null

Japanese

name.​kostring or null

Korean

name.​plstring or null

Polish

name.​ptstring or null

Portuguese

name.​rostring or null

Romanian

name.​rustring or null

Russian

name.​thstring or null

Thai

name.​trstring or null

Turkish

name.​twstring or null

Chinese (Traditional)

name.​vistring or null

Vietnamese

name.​kmstring or null

Khmer

name.​idstring or null

Indonesian

name.​lostring or null

Lao

name.​mystring or null

Burmese

name.​phstring or null

Filipino

name.​nestring or null

Nepali

description(two-letter (object or null)) or (five-letter (object or null))(description-localization-object)

Object with localizations for item’s description. Accepts value in one of two formats: two-letter lowercase language codes (e.g., en) or five-character locale codes (e.g., en-US). While both formats are accepted as input, responses return two-letter lowercase language codes. When both options for the same language are provided (e.g., en and en-US), the last provided value is stored. You can find the full list of supported languages in the documentation.

Any of:

Two-letter lowercase language codes.

description.​enstring or null

English

description.​arstring or null

Arabic

description.​bgstring or null

Bulgarian

description.​cnstring or null

Chinese (Simplified)

description.​csstring or null

Czech

description.​destring or null

German

description.​esstring or null

Spanish (Spain)

description.​frstring or null

French

description.​hestring or null

Hebrew

description.​itstring or null

Italian

description.​jastring or null

Japanese

description.​kostring or null

Korean

description.​plstring or null

Polish

description.​ptstring or null

Portuguese

description.​rostring or null

Romanian

description.​rustring or null

Russian

description.​thstring or null

Thai

description.​trstring or null

Turkish

description.​twstring or null

Chinese (Traditional)

description.​vistring or null

Vietnamese

description.​kmstring or null

Khmer

description.​idstring or null

Indonesian

description.​lostring or null

Lao

description.​mystring or null

Burmese

description.​phstring or null

Filipino

description.​nestring or null

Nepali

long_description(two-letter (object or null)) or (five-letter (object or null))(long-description-localization-object)

Object with localizations for long description of item. Accepts value in one of two formats: two-letter lowercase language codes (e.g., en) or five-character locale codes (e.g., en-US). While both formats are accepted as input, responses return two-letter lowercase language codes. When both variants for the same language are provided (e.g., en and en-US), the last provided value is stored. You can find the full list of supported languages in the documentation.

Any of:

Two-letter lowercase language codes.

long_description.​enstring or null

English

long_description.​arstring or null

Arabic

long_description.​bgstring or null

Bulgarian

long_description.​cnstring or null

Chinese (Simplified)

long_description.​csstring or null

Czech

long_description.​destring or null

German

long_description.​esstring or null

Spanish (Spain)

long_description.​frstring or null

French

long_description.​hestring or null

Hebrew

long_description.​itstring or null

Italian

long_description.​jastring or null

Japanese

long_description.​kostring or null

Korean

long_description.​plstring or null

Polish

long_description.​ptstring or null

Portuguese

long_description.​rostring or null

Romanian

long_description.​rustring or null

Russian

long_description.​thstring or null

Thai

long_description.​trstring or null

Turkish

long_description.​twstring or null

Chinese (Traditional)

long_description.​vistring or null

Vietnamese

long_description.​kmstring or null

Khmer

long_description.​idstring or null

Indonesian

long_description.​lostring or null

Lao

long_description.​mystring or null

Burmese

long_description.​phstring or null

Filipino

long_description.​nestring or null

Nepali

image_urlstring(Virtual-Items-Currency_admin-image_url)

Image URL.

media_listArray of objects(Virtual-Items-Currency_admin-media_list)

Item's additional assets such as screenshots, gameplay video and so on.

media_list[].​typestring

Type of media: image/video.

Enum"image""video"
Example: "image"
media_list[].​urlstring

Resource file.

Example: "https://cdn3.xsolla.com/img/misc/images/71ab1e12126f2103e1868076f0acb21a.jpg"
groupsArray of strings(Virtual-Items-Currency_admin-groups-create)

List of group external IDs the item belongs to.

Example: ["horror", "action"]

attributesArray of objects(Virtual-Items-Currency_admin-post-put-attributes)<= 20 items

List of attributes.

Attention. You can't specify more than 20 attributes for the item. Any attempts to exceed the limit result in an error.
attributes[].​external_idstring(admin-attribute-external_id)[ 1 .. 255 ] characters^[a-zA-Z0-9-_]+$required

Unique attribute ID. The external_id may contain only lowercase and uppercase Latin alphanumeric characters, dashes, and underscores.

attributes[].​nameobject(admin-attribute-name)

Object with localizations for attribute's name. Keys are specified in ISO 3166-1.

attributes[].​name.​property name*stringadditional property
attributes[].​valuesArray of objects(attribute-value)required
Attention. You can't create more than 6 values for each attribute. Any attempts to exceed the limit result in an error.
Example: [{"external_id":"strategy","value":{"en":"Strategy","de":"Strategie"}},{"external_id":"action","value":{"en":"Action","de":"Aktion"}}]
attributes[].​values[].​external_idstring(value-external_id)[ 1 .. 255 ] characters^[-_.\d\w]+$required

Unique value ID for an attribute. The external_id may only contain lowercase Latin alphanumeric characters, dashes, and underscores.

Example: "value_external_id"
attributes[].​values[].​valueobject(value-name)required

Object with localizations of the value's name. Keys are specified in ISO 3166-1.

attributes[].​values[].​value.​property name*stringadditional property
pricesArray of objects(Virtual-Items-Currency_admin-prices)
Example: [{"currency":"USD","amount":10.5,"is_default":true,"is_enabled":true,"country_iso":"US"}]
prices[].​currencystringrequired

Item price currency. Three-letter code per ISO 4217. Check the documentation for detailed information about currencies supported by Xsolla.

Example: "USD"
prices[].​amountnumber> 0required

Item price in real currency.

Example: 10.5
prices[].​is_defaultboolean

Whether it is the default price in real currency. Refer to our documentation for detailed information on price settings.

Default false
Example: true
prices[].​is_enabledboolean

Whether this price is used for displaying in the catalog and for purchasing the item. If false, the price is not used and another price is applied. Refer to our documentation for detailed information on price settings.

Default true
Example: true
prices[].​country_isostring or null

Country where this price is available. Two-letter code per ISO 3166-1 alpha 2.

Example: "US"
vc_pricesArray of objects or null(Virtual-Items-Currency_admin-create-vc_prices)

Array of virtual currency prices.

Example: [{"sku":"com.xsolla.gold_1","amount":10,"is_default":true,"is_enabled":true}]
vc_prices[].​skustring(Virtual-Items-Currency_schemas-sku)required

Unique item ID. The SKU may contain only lowercase and uppercase Latin alphanumeric characters, periods, dashes, and underscores.

Example: "com.xsolla.gold_1"
vc_prices[].​amountintegerrequired

Item price in virtual currency.

Example: 10
vc_prices[].​is_defaultbooleanrequired

Whether it is the default price in virtual currency.

Default false
Example: true
vc_prices[].​is_enabledbooleanrequired

Whether this price is used for displaying in the catalog and for purchasing the item. If false, the price is not used.

Default true
Example: true
is_enabledboolean(Virtual-Items-Currency_is_enabled)

Whether the item is available. If false, the item can't be purchased in the store or obtained as part of a bundle or within a marketing campaign. Refer to our documentation for detailed information about item availability.

is_show_in_storeboolean(Virtual-Items-Currency_is_show_in_store)

Whether the item is displayed in the catalog. If false and is_enabled: true, the item is not visible in the catalog but can be obtained as part of a bundle or within marketing campaigns. Refer to our documentation for detailed information about item availability.

is_freeboolean(value-is_free)

Whether the item is free.

is_paid_randomized_rewardboolean(value-is_paid_randomized_reward)

Whether the item is a randomized paid reward, e.g., a loot box.

orderinteger(Virtual-Items-Currency_order)

Item display order in the catalog. The higher the value, the lower the item appears in the list. If the values are the same, items are sorted by creation date, with newer items displayed higher.

regionsArray of objects(Virtual-Items-Currency_admin-regions)

Array of regions where the item is available. If the array is empty or not passed, the item is available in all regions.

regions[].​idinteger>= 1

Region ID within the project.

Refer to the regional sale restriction documentation and region management API calls for detailed information.

Example: 1
limitsobject(Virtual-Currency-item-limit)

Item limits.

limits.​per_userlimit_per_user (null) or limit_per_user (integer) or limit_per_user (object)(limit_per_user)

Item limitation for a separate user.

Any of:

No per-user item purchase limit.

null(limit_per_user)
limits.​per_iteminteger or null(limit_per_item)

Global item limitation.

limits.​recurrent_scheduleobject or null(virtual_currency_recurrent_schedule)

Limit refresh period.

limits.​recurrent_schedule.​per_userinterval_type = daily (object) or interval_type = weekly (object) or interval_type = monthly (object) or interval_type = hourly (object)

Reset of the purchase limit performed at the specified time interval in hours.

One of:

Daily type of user limits refresh.

limits.​recurrent_schedule.​per_user.​interval_typestringrequired

Recurrent refresh period.

Value"daily"
limits.​recurrent_schedule.​per_user.​timestring((0[0-9]|1[0-9]|2[0-3]):00:00)(\+|-)(0[0-9]|1...required

Time of limit refresh in the desired time zone (rounding to hours).

Example: "02:00:00+03:00"
periodsArray of objects or null(item-periods)

Item sales period.

periods[].​date_fromstring(date-time)

Date when the specified item will be available for sale.

Example: "2020-08-11T10:00:00+03:00"
periods[].​date_untilstring or null(date-time)

Date when the specified item will become unavailable for sale. Can be null.

Example: "2020-08-11T20:00:00+03:00"
custom_attributesobject(json)(item-custom-attributes)<= 500 characters

A JSON object containing item attributes and values. Attributes allow you to add more info to items like the player's required level to use the item. Attributes enrich your game's internal logic and are accessible through dedicated GET methods and webhooks.

curl -i -X PUT \
  -u <username>:<password> \
  https://store.xsolla.com/api/v2/project/44056/admin/items/virtual_currency/sku/crystal \
  -H 'Content-Type: application/json' \
  -d '{
    "sku": "com.xsolla.coin_1",
    "name": {
      "en-US": "Gold coin",
      "de-DE": "Goldmünze"
    },
    "is_enabled": true,
    "is_free": false,
    "is_paid_randomized_reward": false,
    "groups": [
      "gold"
    ],
    "order": 1,
    "description": {
      "en-US": "The main currency of your kingdom",
      "de-DE": "Die Hauptwährung deines Königreichs"
    },
    "prices": [
      {
        "amount": 100,
        "currency": "USD",
        "is_enabled": true,
        "is_default": true
      }
    ],
    "attributes": [
      {
        "external_id": "material",
        "name": {
          "en-US": "Material"
        },
        "values": [
          {
            "external_id": "gold",
            "value": {
              "en-US": "Gold"
            }
          }
        ]
      }
    ],
    "limits": {
      "per_user": 5,
      "per_item": 10000
    },
    "periods": [
      {
        "date_from": "2020-08-11T10:00:00+03:00",
        "date_until": "2020-08-11T20:00:00+03:00"
      }
    ],
    "custom_attributes": {
      "purchased": 0,
      "attr": "value"
    }
  }'

Responses

Virtual currency was successfully updated.

Body
Response
No content

Delete virtual currencyServer-sideAdmin

Request

Deletes a virtual currency.

Security
basicAuth
Path
project_idintegerrequired

Project ID. You can find this parameter in your Publisher Account next to the project name and in the browser address bar when working with a project. The URL has the following format: https://publisher.xsolla.com/<merchant_id>/projects/<project_id>.

Example: 44056
virtual_currency_skustringrequired

Virtual currency SKU.

Example: crystal
curl -i -X DELETE \
  -u <username>:<password> \
  https://store.xsolla.com/api/v2/project/44056/admin/items/virtual_currency/sku/crystal

Responses

Virtual currency was successfully deleted.

Body
Response
No content
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations

Catalog

This API allows getting any kind of sellable items or specific item.

Operations
Operations
Operations
Operations
Operations